/*
 * Rename.h
 *
 *  Created on: Dec 9, 2013
 *      Author: Jan Travnicek
 */

#ifndef RENAME_H_
#define RENAME_H_

#include <automaton/FSM/DFA.h>
#include <automaton/PDA/DPDA.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class Rename : public automaton::VisitableAutomatonBase::const_visitor_type {
public:
	/**
	 * @param dfa automaton to rename
	 */
	static automaton::Automaton rename(const automaton::Automaton& dfa);

	static automaton::DFA rename(const automaton::DFA& dfa);
	static automaton::DPDA rename(const automaton::DPDA& dfa);


protected:
	void Visit(void*, const automaton::EpsilonNFA& automaton) const;
	void Visit(void*, const automaton::MultiInitialStateNFA& automaton) const;
	void Visit(void*, const automaton::NFA& automaton) const;
	void Visit(void*, const automaton::DFA& automaton) const;
	void Visit(void*, const automaton::ExtendedNFA& automaton) const;
	void Visit(void*, const automaton::CompactNFA& automaton) const;
	void Visit(void*, const automaton::DPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopDPDA& automaton) const;
	void Visit(void*, const automaton::InputDrivenNPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownDPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownNPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicDPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicNPDA& automaton) const;
	void Visit(void*, const automaton::NPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopNPDA& automaton) const;
	void Visit(void*, const automaton::OneTapeDTM& automaton) const;

	static const Rename RENAME;
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* RENAME_H_ */
