/*
 * ReverseFSM.h
 *
 *  Created on: 7. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef REVERSE_FSM_H_
#define REVERSE_FSM_H_

#include <automaton/Automaton.h>
#include <automaton/common/State.h>

namespace automaton {

namespace transform {

class ReverseFSM : public VisitableConstFSMBase {
public:
	static automaton::MultiInitialStateNFA convert(const automaton::DFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::NFA& automaton);
	static automaton::MultiInitialStateNFA convert(const automaton::MultiInitialStateNFA& automaton);

	/**
	 * Creates finite automaton accepting reverse language of given automaton
	 * @param automaton FSM
	 * @return Automaton reverse automaton
	 */
	static automaton::Automaton convert( const automaton::Automaton & automaton );
private:
	void Visit(void*, const DFA& automaton) const;
	void Visit(void*, const NFA& automaton) const;
	void Visit(void*, const MultiInitialStateNFA& automaton) const;
	void Visit(void*, const ExtendedNFA& automaton) const;
	void Visit(void*, const EpsilonNFA& automaton) const;
	void Visit(void*, const CompactNFA& automaton) const;

	static const ReverseFSM REVERSE_FSM;
};

} /* namespace transform */

} /* namespace automaton */

#endif /* REVERSE_FSM_H_ */
