/*
 * ToRegExp.h
 *
 *  Created on: 4. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef GRAMMAR_TO_REG_EXP_H_
#define GRAMMAR_TO_REG_EXP_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/LeftRG.h>

#include <regexp/RegExp.h>

namespace grammar {

namespace convert {

class ToRegExp : public grammar::VisitableConstRGBase
{
public:
	/**
	 * @return regexp equivalent to source right regular grammar.
	 * @param grammar Grammar to convert
	 */
	static regexp::RegExp convert(const grammar::Grammar& grammar);

protected:
	void Visit(void*, const grammar::RightRG& grammar) const;
	void Visit(void*, const grammar::LeftRG& grammar) const;
	void Visit(void*, const grammar::RightLG& grammar) const;
	void Visit(void*, const grammar::LeftLG& grammar) const;
	void Visit(void*, const grammar::LG& grammar) const;
	void Visit(void*, const grammar::CFG& grammar) const;
	void Visit(void*, const grammar::EpsilonFreeCFG& grammar) const;
	void Visit(void*, const grammar::CNF& grammar) const;
	void Visit(void*, const grammar::GNF& grammar) const;
	void Visit(void*, const grammar::CSG& grammar) const;
	void Visit(void*, const grammar::NonContractingGrammar& grammar) const;
	void Visit(void*, const grammar::ContextPreservingUnrestrictedGrammar& grammar) const;
	void Visit(void*, const grammar::UnrestrictedGrammar& grammar) const;

	static const ToRegExp TO_REG_EXP;
};

} /* namespace covert */

} /* namespace grammar */

#endif /* GRAMMAR_TO_REG_EXP_H_ */
