/*
 * ExactMatch.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_MATCH_H__
#define _EXACT_MATCH_H__

#include <string/LinearString.h>
#include <string/String.h>

namespace string {

namespace naive {

class ExactMatch : public string::VisitableStringBase::const_same_visitor_type {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static std::set<unsigned> match(const string::String& subject, const string::String& pattern);

	static std::set<unsigned> match(const string::LinearString& subject, const string::LinearString& pattern);
private:
	void Visit(void*, const Epsilon& subject, const Epsilon& pattern) const;
	void Visit(void*, const LinearString& subject, const LinearString& pattern) const;
	void Visit(void*, const CyclicString& subject, const CyclicString& pattern) const;

	static const ExactMatch EXACT_MATCH;
};

} /* namespace naive */

} /* namespace string */

#endif /* _EXACT_MATCH_H__ */
